/**
* DevExtreme (animation/position.d.ts)
* Version: 20.1.2
* Build date: Mon Apr 06 2020
*
* Copyright (c) 2012 - 2020 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
/** Warning! This type is used for internal purposes. Do not import it directly. */
export interface positionConfig {
   /** The target element position that the widget is positioned against. */
    at?: 'bottom' | 'center' | 'left' | 'left bottom' | 'left top' | 'right' | 'right bottom' | 'right top' | 'top' | { x?: 'center' | 'left' | 'right', y?: 'bottom' | 'center' | 'top' };
   /** The element within which the widget is positioned. */
    boundary?: string | Element | JQuery | Window;
   /** Specifies the horizontal and vertical offset from the window's boundaries. */
    boundaryOffset?: string | { x?: number, y?: number };
   /** Specifies how to move the widget if it overflows the screen. */
    collision?: 'fit' | 'fit flip' | 'fit flipfit' | 'fit none' | 'flip' | 'flip fit' | 'flip none' | 'flipfit' | 'flipfit fit' | 'flipfit none' | 'none' | 'none fit' | 'none flip' | 'none flipfit' | { x?: 'fit' | 'flip' | 'flipfit' | 'none', y?: 'fit' | 'flip' | 'flipfit' | 'none' };
   /** The position of the widget to align against the target element. */
    my?: 'bottom' | 'center' | 'left' | 'left bottom' | 'left top' | 'right' | 'right bottom' | 'right top' | 'top' | { x?: 'center' | 'left' | 'right', y?: 'bottom' | 'center' | 'top' };
   /** The target element that the widget is positioned against. */
    of?: string | Element | JQuery | Window;
   /** Specifies horizontal and vertical offset in pixels. */
    offset?: string | { x?: number, y?: number };
}
